# PFotos 1.2 Copyright(C) 2017-2019 Cora Kohlmeier, Frank Hamberg
proc makeButtons {c init binpos lwidth name binvalues {binlist ""}} {
global fs bfs fg cbbg bg wmwidth wmheight gap
global cal_name cal_a cal_rb cal_cb cal_what
global bindata binmax unknownvalue binwidth windowframelist
global langstring lang
global binlabels
makeLabels
# Hier zunächst die übergeordneten Radiobuttons für die globale Selektoren "all" "none" "Manual" aufbauen 
set cal_a($name) $c.1
frame $cal_a($name)  -bg $bg 
grid $cal_a($name) -row 0 -column $binpos -sticky nw -pady 10 

frame $cal_a($name).sel  -bg $bg 
pack $cal_a($name).sel -fill x
label $cal_a($name).sel.name -anchor w  -text $langstring($name,$lang) -font "-size $bfs" -bg $bg -fg $fg
pack $cal_a($name).sel.name -fill x -pady 0  

frame $cal_a($name).sel.all -bg $bg
radiobutton $cal_a($name).sel.all.rb -value -1 -variable cal_rb($name) \
            -command [list selectAll $name $binlist -1] -font "-size $fs" -bg $bg -fg black -highlightthickness 0
label $cal_a($name).sel.all.l -anchor w -width 4 -text $langstring(all,$lang) -font "-size $fs" -bg $bg -fg $fg
pack $cal_a($name).sel.all.rb $cal_a($name).sel.all.l -side left -pady $gap

frame $cal_a($name).sel.none -bg $bg
radiobutton $cal_a($name).sel.none.rb -value -2 -variable cal_rb($name)\
            -command [list selectAll $name $binlist -2] -font "-size $fs" -bg $bg -fg black -highlightthickness 0
label $cal_a($name).sel.none.l -anchor w -width 5 -text $langstring(none,$lang) -font "-size $fs" -bg $bg -fg $fg 
pack $cal_a($name).sel.none.rb $cal_a($name).sel.none.l -side left -pady $gap

frame $cal_a($name).sel.manual -bg $bg
radiobutton $cal_a($name).sel.manual.rb -value -3 -variable cal_rb($name)\
            -command [list selectAll $name $binlist -3] -font "-size $fs" -bg $bg -fg black -highlightthickness 0
label $cal_a($name).sel.manual.l -anchor w -width 6 -text $langstring(manual,$lang) -font "-size $fs" -bg $bg -fg $fg
pack $cal_a($name).sel.manual.rb $cal_a($name).sel.manual.l -side left -pady $gap

if {$name!="Flash"} {
	    pack $cal_a($name).sel.all $cal_a($name).sel.none $cal_a($name).sel.manual  -side left -fill x -padx 0 -pady 5 
	} else {
	    frame $cal_a($name).dummy -bg $bg
	    label $cal_a($name).dummy.l -text "" -font "-size $fs" -bg $bg -fg $fg 
	    pack $cal_a($name).dummy.l -pady $gap
	    pack $cal_a($name).dummy -pady 5

	}

if {$init == 1} {set cal_rb($name) -1}

#hier Breite eines Bins einstellen --- Vorläufig
set w [expr 15*$fs]

set k 1 
set bgcol white
set binfr [frame $c.2 -bg $bg]
grid $binfr -row 2 -column $binpos
# Hier werden jetzt die scrollabel Anteile der Bins gebaut
# erstmal das "Fenster" mit den Scrollbars
set scrwin [ScrolledWindow $binfr.win -scrollbar vertical -auto vertical -size $fs]
grid $scrwin -row 1 -column $binpos -sticky news
grid rowconfigure $scrwin 1 -weight 1 
grid columnconfigure $scrwin $binpos -weight 1

# jetzt den Scrollable Frame für die Inhalte definieren
set scrfr [ScrollableFrame $scrwin.fr -bg $bg -width [expr int(($fs/11.0)*$binwidth($name))]] 
lappend windowframelist $scrfr
grid $scrfr -row 0 -column 0 -sticky news
grid rowconfigure $scrfr 0 -weight 1 
grid columnconfigure $scrfr 0 -weight 1
# Scrollable Frame im Scrolled Window registrieren
$scrwin setwidget $scrfr
# und den zugewiesenen Frame holen und merken
set winframe [$scrfr getframe]

set labelwidth 0
set labellist ""

set cbwidth 0
set labwidth 0
set numwidth 0
set graphwidth 0

# leeres Dummy Label einbauen für Abstand nach unten
frame $winframe.0  -bg $bg
pack $winframe.0  -side bottom -fill x   
label $winframe.0.e -anchor e -width 5 -text "XXXX"  -font "-size $fs" -bg $bg -fg $bg
grid $winframe.0.e -row 0 -column 1 -sticky nw -pady $gap -padx $gap

foreach item [lreverse $binlist] {
  set labelwidth [max $labelwidth [expr 1 + [string length $item]]]
  frame $winframe.$k  -bg $bg
  pack $winframe.$k  -side bottom -fill x   
  set cb [checkbutton $winframe.$k.cb  -variable cal_cb($name,$k) -text ""\
              -command [list selectAll $name $binlist $k] \
              -font "-size $fs" -bg $bg -fg $cbbg -highlightthickness 0]
  if { $item==$unknownvalue } {set text $langstring(unknown,$lang)} else {set text $binlabels($name,$item)}
       
  set binname [label $winframe.$k.l -anchor w -width $lwidth -text $text  -font "-size $fs" -bg $bg -fg $fg]
  lappend labellist $binname
  set number [label $winframe.$k.e -anchor e -width 5 -text 0  -font "-size $fs" -bg $bg -fg $fg]
#  label $cal_a($name).$k.g  -width $w -font "-size $fs" -bg $fg ;#bg option not working on OSX
  set graph [canvas $winframe.$k.g  -width $w -height [expr $fs +3] -bg $bg -highlightbackground $fg]

# und merken für die Updates in UpdateWidget. Die alte Konstruktion war cal_a($name).$k.cb, welche ab nicht zum Konzept ScrolledWindow passt.
# Aber tcl ist ja geduldig, was Arrays angeht
  set cal_a($name,$k.cb) $cb
  set cal_a($name,$k.e) $number
  set cal_a($name,$k.g) $graph

  grid $cb -row 0 -column 0 -sticky nw -pady $gap -padx $gap
  grid $binname -row 0 -column 1 -sticky nw -pady $gap -padx $gap
  grid $number -row 0 -column 2 -sticky nw  -pady $gap -padx $gap
  grid $graph -row 0 -column 3 -sticky we -pady $gap -padx $gap
  
#  if {$k==1} { 
#	  set cbwidth [winfo reqwidth $cb]
#	  set labwidth [winfo reqwidth $binname]
#	  set numwidth [winfo reqwidth $number]
#	  set graphwidth [winfo reqwidth $graph]
#  }
#  pack  $cal_a($name).$k.cb  $cal_a($name).$k.l $cal_a($name).$k.e $cal_a($name).$k.g -side left -fill x -pady $gap -padx 10 
#  $cal_a($name).$k.cb invoke
  if {$init == 1} {
	  set  cal_cb($name,$k) 1
  } 
  incr k
}

foreach lab $labellist {$lab configure -width $labelwidth}
#set required_width [expr $cbwidth + $labwidth + $numwidth + $graphwidth]
#$scrfr configure -width $required_width
$scrfr configure -width $binwidth($name)

}
