# PFotos 1.2 Copyright(C) 2017-2019 Cora Kohlmeier, Frank Hamberg
proc preferences { } {
global parent 
global pfotoshome pfotosrcs datahome imageviewer mainframe toollist
global biniso binfocallength35 binaperture binexposure env_ok warn
global unknownvalue maxbinvalue
global bfs bf cbbg bg fg bfg fs gap cw
global widgetwindow widgetlist filterlist colorscheme bgcolorvalue fgcolorvalue windowframelist DOS
global langstring lang langlist start_histogram excludetypes excludedirs excludefilelist excludefiles
global browserlimit numthumbcolumns
readdefaults
set windowframelist ""
#set bg #888888; #better to read because  fg=black  on OSX for radio buttons 
$mainframe config -bg $bg

set c .top
foreach item [lappend toollist extractExifs openfile about] {
  $c.$item configure -state disabled
}

#Background Color
set backs "white lightgrey grey darkgrey black darkgreen darkblue custom"
# Geometry für Anordnung der Buttons
set hgap 15
frame $mainframe.control -bg $bg
set parent $mainframe.control
pack $parent -side top -fill x -padx {20 0}

#############################################
# Control Buttons
#############################################

frame $parent.data -bg $bg
grid $parent.data -row 0 -column 0 -sticky news 

button $parent.data.s -text $langstring(selectexifdir,$lang) \
       -command {
		   set datadir [dirselect $langstring(selectexifdir,$lang) $home];
		   if {$datadir!=""} {set datahome $datadir; $mainframe.control.data.l configure -text $datahome}
		   } -font "-size $bfs" -bg $bg -fg $bfg

label $parent.data.l -font "-size $bfs" -bg $bg -fg $fg -text "$datahome" 

grid $parent.data.s -row 0 -column 0 -sticky w 
grid $parent.data.l -row 0 -column 1 -sticky w -pady 5 

button $parent.data.vs -text $langstring(selectimageviewer,$lang) \
       -command {
		   set viewer [fileselect $langstring(selectimageviewer,$lang) all $home open];
		   if {$viewer!=""} {set imageviewer $viewer; $mainframe.control.data.vl configure -text [file tail $imageviewer]}
		   } -font "-size $bfs" -bg $bg -fg $bfg


label $parent.data.vl -font "-size $bfs" -bg $bg -fg $fg -text "[file tail $imageviewer]" 

frame $parent.data.lang -bg $bg
grid $parent.data.vs -row 1 -column 0 -sticky w -pady 10
grid $parent.data.vl -row 1 -column 1 -sticky w -pady 10
grid $parent.data.lang -row 1 -column 2 -sticky w -pady 10

label $parent.data.lang.ll -font "-size $bfs" -bg $bg -fg $fg -text $langstring(language,$lang)
pack $parent.data.lang.ll -padx $hgap -pady $gap -fill x
foreach item $langlist {
    frame $parent.data.lang.$item -bg $bg
    pack  $parent.data.lang.$item  -padx $hgap -pady $gap -fill x 
    radiobutton $parent.data.lang.$item.rb -anchor w -variable lang -value $item -font "-size $fs" -bg $bg -fg $bgcolorvalue(black) -highlightthickness 0
    label $parent.data.lang.$item.l  -anchor w -text $item  -font "-size $fs" -bg $bg -fg $fg
    pack  $parent.data.lang.$item.rb $parent.data.lang.$item.l -side left -fill x 
}

if {$DOS!=1} {
	button $parent.data.vd -text $langstring(setsystemimageviewer,$lang) \
	       -command {
			   if {$DOS==0} {set viewer xdg-open}; 
			   if {$DOS>=2} {set viewer open};
			   set imageviewer $viewer;
			   $mainframe.control.data.vl configure -text [file tail $imageviewer]; 
		   } -font "-size $bfs" -bg $bg -fg $bfg
	grid $parent.data.vd -row 2 -column 0 -sticky w
}
if {$env_ok==0} {
	label $parent.data.inf -font "-size $bfs" -bg $bg -fg $warn -text $langstring(warnenv,$lang) 
	grid $parent.data.inf -row 2 -column 1 -sticky w -padx 20
}	
# Apply
frame $parent.buttons -bg $bg
grid $parent.buttons -row 0 -column 2 -sticky ne -padx $hgap -pady $gap
 
button $parent.buttons.back -text $langstring(backtodefaults,$lang) \
       -command {file copy -force  $pfotoshome/pfotosresource.defaults $pfotosrcs/pfotosresource
       setVars
       makeframe preferences; eval preferences
       } -font "-size $bfs" -bg $bg -fg $bfg

button $parent.buttons.cancel -text $langstring(cancel,$lang) \
       -command {restoreHist} \
       -font "-size $bfs" -bg $bg -fg $bfg

button $parent.buttons.apply -text $langstring(apply,$lang) \
       -command {destroy .menubar; menubar; set env_ok 1;
		         writedefaults; 
		         restoreHist;
		         wm minsize . [winfo reqwidth .top] 120} \
       -font "-size $bfs" -bg $bg -fg $bfg

pack $parent.buttons.back  -side left -fill x -padx 0 -pady 0
pack $parent.buttons.cancel -side left -fill x -padx $hgap 
pack $parent.buttons.apply -side left -fill x


frame $mainframe.left -bg $bg
pack $mainframe.left -side left -fill y -padx 0 
set parent $mainframe.left

label $parent.bg -anchor w -text $langstring(background,$lang) -font "-size $bfs"  -bg $bg -fg $fg
pack  $parent.bg -fill x  -padx $hgap  -pady 10

foreach item $backs {
    frame $parent.$item -bg $bg
    pack  $parent.$item  -padx $hgap -pady $gap -fill x 
    radiobutton $parent.$item.rb -anchor w -variable colorscheme -value $item -font "-size $fs" -bg $bg -fg $bgcolorvalue(black) -highlightthickness 0
    label $parent.$item.l  -anchor w -text $langstring($item,$lang)  -font "-size $fs" -bg $bg -fg $fg
    pack  $parent.$item.rb $parent.$item.l -side left -fill x 
}
label $parent.lcc -text $langstring(examplestring,$lang) -font "-size $bfs" -pady 5
button $parent.b_fg -text $langstring(select_fg,$lang) -font "-size $bfs" -command [list color $parent.lcc -fg]
button $parent.b_bg -text $langstring(select_bg,$lang) -font "-size $bfs" -command [list color $parent.lcc -bg]
pack $parent.b_fg $parent.b_bg $parent.lcc -fill x  -padx $hgap 
$parent.lcc configure -fg $fgcolorvalue(custom) -bg $bgcolorvalue(custom) 

proc color {w what} {
	set color -1
	global bgcolorvalue fgcolorvalue langstring lang
    
    if {$what=="-fg"} {set color [tk_chooseColor -title $langstring(select_fg,$lang) -initialcolor $fgcolorvalue(custom)]}
    if {$what=="-bg"} {set color [tk_chooseColor -title $langstring(select_bg,$lang) -initialcolor $bgcolorvalue(custom)]}
		
    if {$color eq {} } return;
    $w configure $what $color
    if {$what=="-fg"} {set fgcolorvalue(custom) $color}
    if {$what=="-bg"} {set bgcolorvalue(custom) $color}
}

# Column width
label $parent.cw -anchor w -text $langstring(column,$lang) -font "-size $bfs" -bg $bg -fg $fg
pack $parent.cw -fill x  -padx $hgap -pady 10

foreach item "10 20 30" {
    frame $parent.cw$item -bg $bg
    pack  $parent.cw$item -padx $hgap -pady $gap -fill x 
    radiobutton $parent.cw$item.rb  -anchor w -variable cw -value $item -font "-size $fs" -bg $bg -fg $bgcolorvalue(black) -highlightthickness 0
    label $parent.cw$item.l -anchor w -text $item -font "-size $fs" -bg $bg -fg $fg
    pack  $parent.cw$item.rb  $parent.cw$item.l -side left -fill x 
}

# Font Size
label $parent.fs -anchor w -text $langstring(font,$lang) -font "-size $bfs" -bg $bg -fg $fg
pack $parent.fs -fill x  -padx $hgap -pady 10

foreach item "6 8 9 10 11 12 13 14 15 16 18" {
    frame $parent.$item -bg $bg
    pack  $parent.$item -padx $hgap -pady $gap -fill x 
    radiobutton $parent.$item.rb  -anchor w -variable fs -value $item -font "-size $fs" -bg $bg -fg $bgcolorvalue(black) -highlightthickness 0
    label $parent.$item.l -anchor w -text $item -font "-size $fs" -bg $bg -fg $fg
    pack  $parent.$item.rb  $parent.$item.l -side left -fill x 
}

# Cams and Lenses and Imagedata
frame $mainframe.halfleft -bg $bg 
pack $mainframe.halfleft -side left -fill y -padx $hgap

set parent $mainframe.halfleft
label $parent.cal -anchor w  -text "$langstring(camslenses,$lang) $langstring(window,$lang)"  -font "-size $bfs" -bg $bg -fg $fg -highlightthickness 0 
pack $parent.cal -pady 10

frame $mainframe.halfright -bg $bg 
pack $mainframe.halfright -side left -fill y -padx $hgap

set parent $mainframe.halfright
label $parent.imd -anchor w  -text "$langstring(imagedata,$lang) $langstring(window,$lang)"  -font "-size $bfs" -bg $bg -fg $fg -highlightthickness 0
pack $parent.imd -pady 10

set ll "$mainframe.halfleft $mainframe.halfright"
set k 1
foreach item $ll {
    foreach widget $widgetlist {
	  if {$widget!="imgname"} {	
	    set what [string tolower $widget ]
        frame $item.$what -bg $bg 
        pack  $item.$what -padx $hgap -pady $gap -fill x 
        checkbutton $item.$what.ccb  -font "-size $fs" -bg $bg -fg $cbbg -onvalue 1 -offvalue 0 -variable widgetwindow($widget,$k) -highlightthickness 0
        label $item.$what.cl  -font "-size $fs" -bg $bg -fg $fg -text $langstring($widget,$lang)
        pack  $item.$what.ccb $item.$what.cl -side left -fill x 
      }
}
incr k

}

#
#Binlists
frame $mainframe.rightright -bg $bg 
pack $mainframe.rightright -side left -fill y -padx $hgap

set parent $mainframe.rightright

# ISO Bins
label $parent.iso -anchor w  -text "$langstring(iso,$lang) $langstring(bins,$lang)"  -font "-size $bfs" -bg $bg -fg $fg
pack $parent.iso -fill x -pady 10
frame $parent.isofull -bg $bg 
pack  $parent.isofull -pady $gap -fill x     
radiobutton $parent.isofull.rb  -font "-size $fs" -bg $bg -fg $bgcolorvalue(black) -highlightthickness 0  \
                 -value "100 200 400 800 1600 3200 6400 12800 25600 51200 102400 $maxbinvalue(iso) $unknownvalue"\
                 -variable biniso
label $parent.isofull.l  -font "-size $fs" -bg $bg -fg $fg -text "100 200 400 800 1600 3200 6400 ..."    
pack  $parent.isofull.rb $parent.isofull.l  -side left -fill x  

frame $parent.isothird -bg $bg 
pack  $parent.isothird -pady $gap -fill x 
radiobutton $parent.isothird.rb -font "-size $fs" -bg $bg -fg $bgcolorvalue(black) -highlightthickness 0 \
             -value "50 64 80 100 125 160 200 250 320 400 480 640 800 1000 1250 1600 2000 2500 3200 4000 5000 6400 8000 10000 12800 $maxbinvalue(iso) $unknownvalue"\
             -variable biniso
label $parent.isothird.l -font "-size $fs" -bg $bg -fg $fg -text "50 64 80 100 125 160 200 250 320 400 ..." 
pack  $parent.isothird.rb $parent.isothird.l  -side left -fill x  




# Aperture Bins
label $parent.apt -anchor w  -text "$langstring(aperture,$lang) $langstring(bins,$lang)" -font "-size $bfs" -bg $bg -fg $fg
pack $parent.apt -fill x -pady 10
frame $parent.aptfull -bg $bg 
pack  $parent.aptfull -pady $gap -fill x    


radiobutton $parent.aptfull.rb  -font "-size $fs" -bg $bg -fg $bgcolorvalue(black) -highlightthickness 0 \
             -value "1 2 2.8 4 5.6 8 11 13 16 22 32 $maxbinvalue(aperture) $unknownvalue"\
             -variable binaperture
label $parent.aptfull.l -font "-size $fs" -bg $bg -fg $fg -text "$langstring(full,$lang): 1 2 2.8 4 5.6 8 11..."
pack  $parent.aptfull.rb $parent.aptfull.l  -side left -fill x  
            
frame $parent.apthalf -bg $bg 
pack  $parent.apthalf -pady $gap -fill x               
radiobutton $parent.apthalf.rb  -font "-size $fs" -bg $bg -fg $bgcolorvalue(black) -highlightthickness 0 \
             -value "1 1.4 2 2.5 2.8 3.5 4 4.5 5.6 6.7 8 9.5 11 13 16 19 22 27 32 $maxbinvalue(aperture) $unknownvalue" \
             -variable binaperture
label $parent.apthalf.l -font "-size $fs" -bg $bg -fg $fg -text "$langstring(half,$lang): 1 1.4 2 2.5 2.8 3.5 4 4.5 5.6 ..."
 pack  $parent.apthalf.rb $parent.apthalf.l  -side left -fill x  
            
             
frame $parent.aptthird -bg $bg 
pack  $parent.aptthird -pady $gap -fill x                  
radiobutton $parent.aptthird.rb -font "-size $fs" -bg $bg -fg $bgcolorvalue(black) -highlightthickness 0 \
            -value "1 1.2 1.4 2 2.2 2.5 2.8 3.2 3.5 4 4.5 5 5.6 6.3 7.1  8 9 10 11 13 14 16 18 20 22 25 29 32 $maxbinvalue(aperture) $unknownvalue" \
            -variable binaperture
label $parent.aptthird.l -font "-size $fs" -bg $bg -fg $fg -text "$langstring(third,$lang):  1 1.2 1.4 2 2.2 2.5 2.8 3.2 3.5 4 4.5 5 5.6 ..."
pack  $parent.aptthird.rb $parent.aptthird.l  -side left -fill x  



# Exposure Bins
label $parent.exp -anchor w  -text "$langstring(exposure,$lang) $langstring(bins,$lang)"  -font "-size $bfs" -bg $bg -fg $fg
pack $parent.exp -fill x -pady 10

frame $parent.expfull -bg $bg 
pack  $parent.expfull -pady $gap -fill x    
radiobutton $parent.expfull.rb  -font "-size $fs" -bg $bg -fg $bgcolorvalue(black) -highlightthickness 0 \
             -value "1/8000 1/4000 1/2000 1/1000 1/500 1/250 1/125 1/60 1/30 1/15 $maxbinvalue(exposure) $unknownvalue"\
             -variable binexposure            
label $parent.expfull.l  -font "-size $fs" -bg $bg -fg $fg -text "$langstring(full,$lang): 1/8000 1/4000 1/2000 1/1000 1/500 1/250 1/125 1/60 1/30 1/15" 
pack  $parent.expfull.rb $parent.expfull.l  -side left -fill x  
        
frame $parent.exphalf -bg $bg 
pack  $parent.exphalf -pady $gap -fill x              
radiobutton $parent.exphalf.rb  -font "-size $fs" -bg $bg -fg $bgcolorvalue(black) -highlightthickness 0 \
             -value "1/32000 1/16000 1/8000 1/4000 1/2000 1/1000 1/500 1/200 1/100 1/60 1/30 $maxbinvalue(exposure) $unknownvalue"\
             -variable binexposure
label $parent.exphalf.l  -font "-size $fs" -bg $bg -fg $fg -text "$langstring(short,$lang): 1/32000 1/16000 1/8000 1/4000 1/2000 1/1000 1/500 1/200 1/100 1/60 1/30"
pack  $parent.exphalf.rb $parent.exphalf.l  -side left -fill x  

frame $parent.expthird -bg $bg 
pack  $parent.expthird -pady $gap -fill x               
radiobutton $parent.expthird.rb -font "-size $fs" -bg $bg -fg $bgcolorvalue(black) -highlightthickness 0 \
            -value "1/500 1/200 1/100 1/60 1/30 1/10 1/8 1/4 $maxbinvalue(exposure) $unknownvalue"\
            -variable binexposure
label $parent.expthird.l -font "-size $fs" -bg $bg -fg $fg -text "$langstring(long,$lang):  1/500 1/200 1/100 1/60 1/30 1/10 1/8 1/4"
pack  $parent.expthird.rb $parent.expthird.l  -side left -fill x  
          

# Focal length 35mm equiv Bins
#############################################

label $parent.fl35 -anchor w  -text "$langstring(focallength35,$lang) $langstring(bins,$lang)"  -font "-size $bfs" -bg $bg -fg $fg
pack $parent.fl35 -fill x -pady 10

frame $parent.fl35half -bg $bg 
pack  $parent.fl35half -pady $gap -fill x           
radiobutton $parent.fl35half.rb  -font "-size $fs" -bg $bg -fg $bgcolorvalue(black) -highlightthickness 0  \
             -value "8 10 12 14 20 50 70 100 150 200 300 400 $maxbinvalue(focallength35) $unknownvalue" \
             -variable binfocallength35
label $parent.fl35half.l  -font "-size $fs" -bg $bg -fg $fg -text "$langstring(short,$lang): 8 10 12 14 20 50 70 100 150 200 300 400 "
pack  $parent.fl35half.rb $parent.fl35half.l  -side left -fill x  
  
frame $parent.fl35full -bg $bg 
pack  $parent.fl35full -pady $gap -fill x 
radiobutton $parent.fl35full.rb  -font "-size $fs" -bg $bg -fg $bgcolorvalue(black) -highlightthickness 0 \
             -value "16 24 35 50 70 100 150 200 250 300 400 500 600 800 $maxbinvalue(focallength35) $unknownvalue" \
             -variable binfocallength35
label $parent.fl35full.l  -font "-size $fs" -bg $bg -fg $fg -text "$langstring(normal,$lang): 16 24 35 50 70 100 150 200 250 300 400 500 600 800" 
pack  $parent.fl35full.rb $parent.fl35full.l  -side left -fill x  

frame $parent.fl35third -bg $bg 
pack  $parent.fl35third -pady $gap -fill x  
radiobutton $parent.fl35third.rb -font "-size $fs" -bg $bg -fg $bgcolorvalue(black) -highlightthickness 0  \
            -value "50 100 200 300 400 500 600 700 800 1000 1200 1500 2000 $maxbinvalue(focallength35) $unknownvalue" \
            -variable binfocallength35
label $parent.fl35third.l -font "-size $fs" -bg $bg -fg $fg -text "$langstring(long,$lang): 50 100 200 300 400 500 600 700 800 1000 1200 1500 2000" 
pack  $parent.fl35third.rb $parent.fl35third.l  -side left -fill x  

# Focal length orig Bins
#############################################

label $parent.fl -anchor w  -text "$langstring(focallength,$lang) $langstring(bins,$lang)"  -font "-size $bfs" -bg $bg -fg $fg
pack $parent.fl -fill x -pady 10

frame $parent.flvs -bg $bg 
pack  $parent.flvs -pady $gap -fill x           
radiobutton $parent.flvs.rb  -font "-size $fs" -bg $bg -fg $bgcolorvalue(black) -highlightthickness 0  \
             -value "2 4 6 8 10 12 14 20 50 70 100 120 150 200 $maxbinvalue(focallength) $unknownvalue" \
             -variable binfocallength
label $parent.flvs.l  -font "-size $fs" -bg $bg -fg $fg -text "$langstring(veryshort,$lang): 2 4 6 8 10 12 14 20 50 70 100 120 150 200"
pack  $parent.flvs.rb $parent.flvs.l  -side left -fill x  

frame $parent.flhalf -bg $bg 
pack  $parent.flhalf -pady $gap -fill x           
radiobutton $parent.flhalf.rb  -font "-size $fs" -bg $bg -fg $bgcolorvalue(black) -highlightthickness 0  \
             -value "8 10 12 14 20 50 70 100 150 200 300 400 $maxbinvalue(focallength) $unknownvalue" \
             -variable binfocallength
label $parent.flhalf.l  -font "-size $fs" -bg $bg -fg $fg -text "$langstring(short,$lang): 8 10 12 14 20 50 70 100 150 200 300 400 "
pack  $parent.flhalf.rb $parent.flhalf.l  -side left -fill x  

frame $parent.flfull -bg $bg 
pack  $parent.flfull -pady $gap -fill x 
radiobutton $parent.flfull.rb  -font "-size $fs" -bg $bg -fg $bgcolorvalue(black) -highlightthickness 0 \
             -value " 10 16 24 35 50 70 100 135 170 200 250 300 350 400 500 $maxbinvalue(focallength) $unknownvalue" \
             -variable binfocallength
label $parent.flfull.l  -font "-size $fs" -bg $bg -fg $fg -text "$langstring(normal,$lang): 10 16 24 35 50 70 100 135 170 200 250 300 350 400 500" 
pack  $parent.flfull.rb $parent.flfull.l  -side left -fill x  

frame $parent.flthird -bg $bg 
pack  $parent.flthird -pady $gap -fill x  
radiobutton $parent.flthird.rb -font "-size $fs" -bg $bg -fg $bgcolorvalue(black) -highlightthickness 0  \
            -value "35 50 100 200 300 400 500 600 700 800 1000 1200 $maxbinvalue(focallength) $unknownvalue" \
            -variable binfocallength
label $parent.flthird.l -font "-size $fs" -bg $bg -fg $fg -text "$langstring(long,$lang): 35 50 100 200 300 400 500 600 700 800 1000 1200" 
pack  $parent.flthird.rb $parent.flthird.l  -side left -fill x  

frame $mainframe.control.bottom -bg $bg
set parent $mainframe.control.bottom
grid $parent -row 1 -column 0 -sticky nw

# Text input for file names, file types and directories to exclude
frame $parent.exclude1 -bg $bg
pack  $parent.exclude1 -padx 0 -pady {20 0} -fill x  
label $parent.exclude1.l -font "-size $bfs" -bg $bg -fg $fg -text "$langstring(defdirs,$lang):"
entry $parent.exclude1.input -width 80  -textvariable excludedirs -font "-size $bfs" -bg $fg -fg $bg -highlightthickness 0 -borderwidth 0
pack $parent.exclude1.l $parent.exclude1.input -side left -fill x

frame $parent.exclude2 -bg $bg
pack  $parent.exclude2 -padx 0 -pady {5 0} -fill x  
label $parent.exclude2.l -font "-size $bfs" -bg $bg -fg $fg -text "$langstring(deffiles,$lang):"
entry $parent.exclude2.input -width 80  -textvariable excludefiles -font "-size $bfs" -bg $fg -fg $bg -highlightthickness 0 -borderwidth 0
pack $parent.exclude2.l $parent.exclude2.input -side left -fill x

frame $parent.exclude3 -bg $bg
pack  $parent.exclude3 -padx 0 -pady {5 0} -fill x  
label $parent.exclude3.l -font "-size $bfs" -bg $bg -fg $fg -text "$langstring(deftypes,$lang):"
entry $parent.exclude3.input -width 80  -textvariable excludetypes -font "-size $bfs" -bg $fg -fg $bg -highlightthickness 0 -borderwidth 0
pack $parent.exclude3.l $parent.exclude3.input -side left -fill x

frame $parent.browserlimit -bg $bg
pack  $parent.browserlimit -padx 0 -pady {5 0} -fill x  
label $parent.browserlimit.l -font "-size $bfs" -bg $bg -fg $fg -text "$langstring(browserlimit,$lang):"
entry $parent.browserlimit.input -width 5  -textvariable browserlimit -font "-size $bfs" -bg $fg -fg $bg -highlightthickness 0 -borderwidth 0
pack $parent.browserlimit.l $parent.browserlimit.input -side left -fill x

frame $parent.numthumbcolumns -bg $bg
pack  $parent.numthumbcolumns -padx 0 -pady {5 0} -fill x  
label $parent.numthumbcolumns.l -font "-size $bfs" -bg $bg -fg $fg -text "$langstring(numthumbcolumns,$lang):"
entry $parent.numthumbcolumns.input -width 5  -textvariable numthumbcolumns -font "-size $bfs" -bg $fg -fg $bg -highlightthickness 0 -borderwidth 0
pack $parent.numthumbcolumns.l $parent.numthumbcolumns.input -side left -fill x}



