# PFotos 1.2 Copyright(C) 2017-2019 Cora Kohlmeier, Frank Hamberg
proc extract35mmEquiv {input} {
set output $input
 if {[string match "*mm*" $input]} {
  regsub -all {mm} $input "" a
  if [string match "*:*" $a] {
    set b [split $a ":"]
    regsub {\)} [lindex $b 1] "" c
    regsub -all { } $c "" output
  } else {
    set output $a
  }
 }
 if {[isnumeric $output] !=""} {
     return [expr floor($output)]
 } else {
	 return $output
 }	     
}   

proc extractmm {input} {
set output $input
 if {[string match "*mm*" $input]} {
  regsub -all {mm} $input "" a	
  regsub -all { } $a "" output
 }
return $output
}   

proc extractLens {input} {
  if [string match "*or Sigma*" $input] {
	  regsub -all "or " $input "ß" a
	  set b [lindex [split $a "ß"] 1]
  } else { 
	  set b $input
  }
  regsub -all {\[} $b "" a	
  regsub -all {\]} $a "" output	 
return $output
}   

proc extractFlash {input} {
   if {[string match "*Fired*" $input] || ($input=="yes")} {
	set output yes
   } else {
	set output no
   }  
return $output
}

proc maskSpace {input} {
  regsub -all " " $input "\\ " output
  return $output	
}

proc maskSpace2 {input} {
  global DOS
  if {$DOS==1} {
    regsub -all "\/" $input "\\" output
#    regsub -all " " $input " " output
  } else {
    regsub -all " " $input "\\ " output
  }  
return $output	
}

proc removeSpace {input} {
  regsub -all " " $input "" output
  return $output	
}

proc checkUnknown {input} {
	if {[string match "unknown" $input] || \
		[string match "inf" $input] || \
		[string match "undef" $input] || \
		[string match "-" $input] } {
			return 1
		} else {
			return 0
		} 
}

proc isnumeric value {
    set value [string trim $value]
    # Use [string is double] to accept Inf and NaN
    if {[string is double -strict $value]} {
        return $value
    }
    regsub {^\s*([+-])*0[BOXbox]?0*([^[:space:]]*)\s*$} $value {\1\2} value
    if {[string is double -strict $value]} {
        return $value
    }
    return {} 
}
